<template>
	<div class="details row-padding col-padding azure-gradient lightestazure-color">
		<div class="header flex space">
			<div class="label hustle flex v-center space" v-bind:class="{ 'edit-mode': edit_mode }">
				<span v-if="!edit_mode">{{vairus.label}}</span>
				
				<form v-on:submit.prevent="toggleEditMode">
					<input class="hustle name-edit" type="text" v-show="edit_mode" v-model="label" spellcheck="false" :maxlength="14" ref="label">
				</form>
				
				<div class="edit-icon" v-on:click="toggleEditMode">
					<div class="inner" v-bind:style="{'background-image' : edit_icon}"></div>
				</div>
			</div>
			
			<div class="catch-date small-font">
				<div class="uppercase">{{getLocale('catch_date')}}</div>
				<div>{{formatDate(vairus.catch_time)}}</div>
			</div>
			
			<div class="category small-font">
				<div class="uppercase">{{getLocale('category')}}</div>
				<div>{{getLocale(vairus.vairus_type.biome)}}</div>
			</div>
			
			<div class="rarity small-font">
				<div class="uppercase">{{getLocale('rarity')}}</div>
				<div>{{getLocale(vairus.vairus_type.rarity)}}</div>
			</div>
			
			<div class="potential small-font" v-tooltip="'potential_tooltip'">
				<div class="text uppercase">{{getLocale('potential')}} {{vairus.potential+'%'}}</div>
				
				<div class="flex bar-wrapper">
					<div class="bar flex">
						<div class="base" :style="{ width: vairus.potential+'%' }"></div>
					</div>
				</div>
			</div>
			
			<div class="flex icons">
				<tutorial-icon color="#B3EDFF" @clicked="setTutorial('vairus_details', -1, true)"/>
				<close-icon color="#B3EDFF" @clicked="$emit('close')"/>
			</div>
		</div>
		
		<div class="content flex">
			<div class="info">
				<div class="level" :class="{active : (target_level != vairus.level)}">
					<div class="top-section uppercase">
						{{getLocale('level')}}
					</div>
					
					<div class="level-section flex v-center">
						<div class="current-level-bar" :style="{width : (vairus.level*2)+'%'}"></div>
						<vue-range-slider  
							v-model="(target_level)"
							value="target_level"
							:speed="0"
							:min="vairus.level" 
							:max="50" 
							:tooltip="false"
							:style="{width : ((50 - vairus.level)*2)+'%'}"
						></vue-range-slider>
					</div>
					
					<div class="info-section">
						<table>
						  <tr>
							<th></th>
							<th v-tooltip="'key_tooltip'"><img class="key" v-bind:src="getImage('key1.png')"></th>
							<th v-tooltip="'key_tooltip'"><img class="key" v-bind:src="getImage('key2.png')"></th>
							<th v-tooltip="'key_tooltip'"><img class="key" v-bind:src="getImage('key3.png')"></th>
							<th v-tooltip="'key_tooltip'"><img class="key" v-bind:src="getImage('key4.png')"></th>
							<th><bytes-icon class="icon"/></th>
						  </tr>
						  <tr>
							<td class="small-font">{{getLocale('available')}}</td>
							<td v-tooltip="'key_tooltip'" :class="[(keys[0] >= levelup_cost.keys[0]) ? 'green-color' : 'red-color']">{{keys[0]}}</td>
							<td v-tooltip="'key_tooltip'" :class="[(keys[1] >= levelup_cost.keys[1]) ? 'green-color' : 'red-color']">{{keys[1]}}</td>
							<td v-tooltip="'key_tooltip'" :class="[(keys[2] >= levelup_cost.keys[2]) ? 'green-color' : 'red-color']">{{keys[2]}}</td>
							<td v-tooltip="'key_tooltip'" :class="[(keys[3] >= levelup_cost.keys[3]) ? 'green-color' : 'red-color']">{{keys[3]}}</td>
							<td :class="[(bytes   >= levelup_cost.bytes  ) ? 'green-color' : 'red-color']">{{bytes}}</td>
						  </tr>
						  <tr>
							<td class="small-font">{{getLocale('required')}}</td>
							<td v-tooltip="'key_tooltip'">{{levelup_cost.keys[0]}}</td>
							<td v-tooltip="'key_tooltip'">{{levelup_cost.keys[1]}}</td>
							<td v-tooltip="'key_tooltip'">{{levelup_cost.keys[2]}}</td>
							<td v-tooltip="'key_tooltip'">{{levelup_cost.keys[3]}}</td>
							<td>{{levelup_cost.bytes}}</td>
						  </tr>
						</table>
					</div>
				</div>
				<div class="level-action" :class="{active : (target_level != vairus.level), locked : target_level != vairus.level && checkPowerUpCost}">
					<div class="powerup bold uppercase" v-on:click="startPowerup">
						<span class="active">{{getLocale('powerup')}}</span>
						<span class="locked">{{getLocale('not_enough_resources')}}</span>
					</div>
					
					<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 420 40">
						<path pointer-events="visible" stroke="#B3EDFF" stroke-width="2" fill="black" d="M 0 1 L 280 1 L 320 39 L 420 39 L 419 -2 L 0 -2 Z"></path>
					</svg>
					
					<div class="label align-center">LV<strong>{{target_level}}</strong></div>
				</div>
				
				<div class="image-wrapper" >
					<vairus-image :vairus="vairus" :glitch="glitched"/>
					<div class="exhausted" :class="exhausted" v-if="exhausted"><span>
						<span>{{getLocale('exhausted_'+exhausted)}}<br></span>
						<span v-if="exhaustion_left">{{exhaustion_left}}</span>
					</span></div>
				</div>
				
				<div class="mutations-action" :class="{active : (mutation_to_add != null && shards[mutation_to_add] >= mutationCost), locked : (mutation_to_add != null && shards[mutation_to_add] < mutationCost)}">
					<div class="powerup bold uppercase" v-on:click="startMutation(mutation_to_add)">
						<span class="active">{{getLocale('mutate')}}</span>
						<span class="locked">{{getLocale('not_enough_fragments')}}</span>
					</div>
					
					<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 420 40">
						<path pointer-events="visible" stroke="#B3EDFF" stroke-width="2" fill="black" d="M 0 39 L 280 39 L 320 1 L 420 1 L 419 42 L 0 42 Z"></path>
					</svg>
					
					<div class="label flex space" v-on:click="toggleMutationMode">
						<div class="mutation" 
							:class="[ 
								mutation_to_add != null ? 'selected' : '',
								vairus.attributes.length >= 1 ? 'active '+vairus.attributes[0]+'-bkg' : '',
								mutation_to_add != null && vairus.attributes.length == 0  ? mutation_to_add+'-bkg' : ''
							]"
						><span v-if="vairus.attributes.length == 0">+</span></div>
						<div class="mutation"
							:class="[ 
								vairus.attributes.length >= 2 ? 'active '+vairus.attributes[1]+'-bkg' : '',
								mutation_to_add != null && vairus.attributes.length == 1  ? mutation_to_add+'-border' : ''
							]"
						><span v-if="vairus.attributes.length == 1">+</span></div>
					</div>
				</div>
				
				<div class="mutations"  :class="{active : mutation_toggle}">
					<div class="info-section">
						<div class="wrapper flex space">
							<div class="labels small-font">
								<div class="empty">&nbsp;</div>
								<div>{{getLocale('available')}}</div>
								<div>{{getLocale('required')}}</div>
							</div>
							
							<div class="affinities align-center flex h-center">
								<div class="affinity" :class="{selected : mutation_to_add == affinity}" v-for="affinity in affinitiesList" v-on:click="mutation_to_add = affinity" v-tooltip="affinity">
									<img class="key" v-bind:src="getImage('shards/'+affinity+'.png')">
									<div :class="[(shards[affinity] >= mutationCost) ? 'green-color' : 'red-color']">{{shards[affinity]}}</div>
									<div>{{mutationCost}}</div>
								</div>
							</div>
						</div>
					</div>
				
					<div class="bottom-section uppercase" v-on:click="toggleMutationMode">
						{{getLocale('mutations')}}
					</div>
				</div>
			</div>
			
			<div class="stats">
				<div class="graph-wrapper">
					<div class="graph">
						<svg xmlns="http://www.w3.org/2000/svg" width="100" height="100" viewBox="-50 -50 100 100">
							<defs>
								<radialGradient id="gradient" 
									:cx="modified_stats.adaptability / (modified_stats.adaptability + modified_stats.secrecy)" 
									:cy="modified_stats.hazard / (modified_stats.hazard + modified_stats.rapidity)" 
								>
									<stop offset="0%" stop-color="transparent" />
									<stop offset="100%" stop-color="white" />
								</radialGradient>
							</defs>
							
							<polygon v-if="phantoms_sum > 0" :points="'0,-'+modified_stats.hazard/3.08+' '+modified_stats.secrecy/3.08+',0 0,'+modified_stats.rapidity/3.08+' -'+modified_stats.adaptability/3.08+',0'" fill="#00FFB4" />
							<polygon :points="'0,-'+vairus.current_stats.hazard.total/3.08+' '+vairus.current_stats.secrecy.total/3.08+',0 0,'+vairus.current_stats.rapidity.total/3.08+' -'+vairus.current_stats.adaptability.total/3.08+',0'" :fill="phantoms_sum > 0 ? 'black' : 'white'" />
							
							<circle r="45" fill="none" stroke="rgba(255,255,255,0.25)" stroke-width="0.5" />
							<circle r="30" fill="none" stroke="rgba(255,255,255,0.25)" stroke-width="0.5" />
							<circle r="15" fill="none" stroke="rgba(255,255,255,0.25)" stroke-width="0.5" />
						</svg>	
					
						<div class="x-axis small-font align-center">
							<div class="labels">
								<div class="stat-label">
									<div class="text">{{getLocale('secrecy')}}</div>
									<div class="image lightestazure-bkg">
										<img class="icon" v-bind:src="getImage('secrecy.svg')">
									</div>
								</div>
								
								<div class="stat-label">
									<div class="image lightestazure-bkg">
										<img class="icon" v-bind:src="getImage('adaptability.svg')">
									</div>
									<div class="text">{{getLocale('adaptability')}}</div>
								</div>
							</div>
							
							<div class="bubbles small-font">
								<div class="bubble" :style="{
									bottom : (50 + modified_stats.secrecy/3.08)+'%',
									top    : (50 + modified_stats.secrecy/3.08)+'%'
								}">
									{{ vairus.current_stats['secrecy'].total + phantoms['secrecy']}}
								</div>
								<div class="bubble" :style="{
									bottom : (50 + modified_stats.adaptability/3.08)+'%',
									top    : (50 + modified_stats.adaptability/3.08)+'%'
								}">
									{{ vairus.current_stats['adaptability'].total + phantoms['adaptability']}}
								</div>
							</div>
						</div>
						
						<div class="y-axis small-font align-center">
							<div class="labels">
								<div class="stat-label">
									<div class="text">{{getLocale('hazard')}}</div>
									<div class="image lightestazure-bkg">
										<img class="icon" v-bind:src="getImage('hazard.svg')">
									</div>
								</div>
								
								<div class="stat-label">
									<div class="image lightestazure-bkg">
										<img class="icon" v-bind:src="getImage('rapidity.svg')">
									</div>
									<div class="text">{{getLocale('rapidity')}}</div>
								</div>
							</div>
							
							<div class="bubbles small-font">
								<div class="bubble" :style="{
									bottom : (50 + modified_stats.hazard/3.08)+'%',
									top    : (50 + modified_stats.hazard/3.08)+'%'
								}">
									{{ vairus.current_stats['hazard'].total + phantoms['hazard']}}
								</div>
								<div class="bubble" :style="{
									bottom : (50 + modified_stats.rapidity/3.08)+'%',
									top    : (50 + modified_stats.rapidity/3.08)+'%'
								}">
									{{ vairus.current_stats['rapidity'].total + phantoms['rapidity']}}
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import VButton from '../components/VButton.vue';
	import BytesIcon from '../components/BytesIcon.vue';
	import CloseIcon from '../components/CloseIcon.vue';
	import TutorialIcon from '../components/TutorialIcon.vue';
	import VairusImage from '../components/VairusImage.vue';
	import levelManager from '../classes/levelManagerClass.js';
	import raritiesManager from '../classes/raritiesManagerClass.js';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	import 'vue-range-component-fixed/dist/vue-range-slider.css'
	import VueRangeSlider from 'vue-range-component-fixed'

	export default {
		props: ['vairus'],
		data: function () {
			return{
				edit_mode : false,
				exhausted : false,
				exhaustion_left : 0,
				exhaustion_interval : null,
				edit_icon : 'url('+browser.runtime.getURL('/images/edit-light.svg')+')',
				label : '',
				stats_list : ['hazard', 'secrecy', 'adaptability', 'rapidity'],
				phantoms : {
					hazard : 0,
					secrecy : 0,
					adaptability : 0,
					rapidity : 0
				},
				mutation_toggle : false,
				level_panel : false,
				level_to_add : 0,
				mutation_to_add : null,
				powerup_disabled : false,
				mutation_disabled : false
			}
		},
		created() {
			this.updateExhaustion();
			this.exhaustion_interval = setInterval(this.updateExhaustion, 1000);
		},
		beforeDestroy() {
			clearInterval(this.exhaustion_interval);
		},
		methods: {
			formatDate(date){
				date = new Date(date);
				
				let day = date.getDate();
				let month = date.getMonth()+1;
				let year = date.getFullYear();
				
				return day.toString().padStart(2, '0')+'/'+month.toString().padStart(2, '0')+'/'+year;
			},
			toggleEditMode(){
				this.edit_mode = !this.edit_mode;
				if(this.edit_mode){
					this.label = this.$props.vairus.label;
					this.$nextTick(() => this.$refs.label.focus())
					this.edit_icon = 'url('+browser.runtime.getURL('/images/tick-light.svg')+')';
				}else{
					this.$emit('edit_label', this.label);
					this.edit_icon = 'url('+browser.runtime.getURL('/images/edit-light.svg')+')';
				}
			},
			toggleMutationMode(){
				this.level_to_add = 0;
				setTimeout(function(){
					if(this.vairus.attributes.length < 2){
						this.mutation_toggle = !this.mutation_toggle;
						if(!this.mutation_toggle){
							this.mutation_to_add = null;
						}
					}
				}.bind(this), 0);
			},
			toggleLevelMode(){
				this.level_panel = !this.level_panel;
				this.target_level = this.$props.vairus.level;
			},
			startMutation(type){
				if(!this.mutation_disabled){
					let shards = this.shards;
					let current_attributes_number = this.$props.vairus.attributes.length;
					
					if(shards[type] >= this.mutationCost){	
						this.mutation_disabled = true;
						setTimeout(() => { this.mutation_disabled = false; }, 2000);
						
						browser.runtime.sendMessage({
							type : 'mutate_vairus',
							data : { 
								mutation_id : this.$props.vairus.unique_id,
								type : type
							}
						}, function(response) {
							if(response.success && (current_attributes_number+1) >= 2){
								this.mutation_toggle = false;
							}
							this.mutation_to_add = null;
							this.mutation_disabled = false;
						}.bind(this));
					}
				}
			},
			startPowerup(){	
				if(!this.powerup_disabled && !this.checkPowerUpCost){
					if(this.bytes >= this.levelup_cost.bytes && this.level_to_add > 0){	
						this.powerup_disabled = true;
						setTimeout(() => { this.powerup_disabled = false; }, 2000);
						
						browser.runtime.sendMessage({
							type : 'powerup_vairus',
							data : { 
								vairus_id : this.$props.vairus.unique_id,
								level_to_add : this.level_to_add
							}
						}, function(response) {
							this.target_level = this.$props.vairus.level;
							this.powerup_disabled = false;
						}.bind(this));
					}
				}
			},
			nextDetail(type){
				this.$emit('next_detail', this.$props.vairus.unique_id, type);
			},
			updateExhaustion(){
				let current_time = Date.now();
				
				let exhaustion = this.$props.vairus.exhaustion;
				
				if(exhaustion == null){
					this.exhausted = null;
				}else if(typeof exhaustion == 'string'){
					this.exhausted = exhaustion;
				}else{
					this.exhausted = (current_time < this.$props.vairus.exhaustion) ? 'exhausted' : null;
				}
				
				if(this.exhausted === 'exhausted'){
					if(this.$props.vairus.exhaustion != null)
						this.exhaustion_left = this.parseTime(exhaustion-current_time);
					else
						this.exhaustion_left = browser.i18n.getMessage('assigned');
				} 
			},
			setPhantom(stat, value){
				this.phantoms[stat] = value;
			},
			setAllPhantomsOff(){
				for(var type in this.phantoms){
					this.phantoms[type] = 0;
				}
			},
			toggleAffinityPhantom(affinity, type){
				let stat = '';
			
				switch(affinity){
					case 'fire': 	case 'earth':  	 stat = 'hazard'; break;
					case 'water': 	case 'acid':  	 stat = 'secrecy'; break;
					case 'nature':	case 'electric': stat = 'adaptability'; break;
					case 'air': 	case 'ice':  	 stat = 'rapidity'; break;
				}
				
				if(type == 'on'){
					this.setPhantom(stat, Math.floor(this.$props.vairus.current_stats[stat].base*0.2));
				}else{
					this.setPhantom(stat, 0);
				}
			},
			parseTime(timestamp){
				let h = Math.floor(timestamp/1000/60/60);
				let m = Math.floor((timestamp/1000/60/60 - h)*60);
				let s = Math.floor(((timestamp/1000/60/60 - h)*60 - m)*60);
				
				if(m<10)m = '0'+m;
				if(s<10)s = '0'+s;
				
				return h+':'+m+':'+s;
			},
			updateTargetLevel(e){
				if((e.target.value - this.$props.vairus.level) < 0)
					this.level_to_add = 0;
			},
		},
		computed: {
			glitched(){
				return this.vairus.attributes.indexOf('glitch') !== -1;
			},
			mutationCost(){
				let rarity = raritiesManager.getRarityByName(this.$props.vairus.vairus_type.rarity);
				return 100 * rarity.multiplier;
			},
			affinitiesList(){
				let affinities = this.$props.vairus.vairus_type.affinities;
				let affinities_list = [];
				
				for(let affinity in affinities){
					if(affinities[affinity] == 'normal'){
						affinities_list.push(affinity);
					}
				}
				
				return affinities_list.filter(function(affinity){
					return this.$props.vairus.attributes.indexOf(affinity) === -1;
				}.bind(this));
			},
			target_level: {
				get(){
					return this.$props.vairus.level + this.level_to_add;
				},
				set(val){
					let phantomStats = levelManager.getPhantomStats(this.$props.vairus, val);	
					
					if(val > this.$props.vairus.level){
						for(let stat in this.phantoms){
							this.phantoms[stat] = phantomStats[stat].total - this.$props.vairus.current_stats[stat].total;
						}
					}else{
						for(let stat in this.phantoms){
							this.phantoms[stat] = 0;
						}
					}
					
					this.level_to_add = val - this.$props.vairus.level;
				}
			},
			levelup_cost(){
				let from_level = this.$props.vairus.level;
				let to_level = from_level + this.level_to_add;
				let rarity = this.$props.vairus.vairus_type.rarity;
				
				return {
					bytes : levelManager.getCostRange(from_level, to_level, rarity),
					keys : levelManager.getKeysRange(from_level, to_level, rarity)
				}
			},
			checkPowerUpCost(){
				let byte_check = !(this.levelup_cost.bytes <= this.bytes && this.levelup_cost.bytes > 0);
				let key_check = false;
				
				this.levelup_cost.keys.forEach(function(value, index){
					if(value > this.keys[index]){
						key_check = true;
					}
				}.bind(this));
				
				return (byte_check || key_check);
			},
			potential(){
				let bonus_points_string = ('0000'+this.$props.vairus.bonus_points).slice(-4);
				let total = 0;
				
				for(let i=0; i<4; i++){
					total+= parseInt(bonus_points_string[i])+1;
				}
				
				return Math.floor((total*100)/40);
			},
			modified_stats(){
				return {
					hazard : this.vairus.current_stats['hazard'].total + this.phantoms['hazard'],
					secrecy : this.vairus.current_stats['secrecy'].total + this.phantoms['secrecy'],
					adaptability : this.vairus.current_stats['adaptability'].total + this.phantoms['adaptability'],
					rapidity : this.vairus.current_stats['rapidity'].total + this.phantoms['rapidity']
				}
			},
			phantoms_sum(){
				return this.phantoms['hazard']+this.phantoms['secrecy']+this.phantoms['adaptability']+this.phantoms['rapidity'];
			}
		},
		watch: { 
			vairus: function() {
				this.target_level = this.$props.vairus.level;
			},
			target_level: function() {
				this.mutation_toggle = false;
				this.mutation_to_add = null;
			},
			mutation_to_add: function(affinity) {
				if(affinity != null){
					this.setAllPhantomsOff();
					this.toggleAffinityPhantom(affinity, 'on');
				}else{
					this.setAllPhantomsOff();
				}
			}
		},
		mixins: [commonMixin, storeGettersMixin],
		components: {
			VButton,
			BytesIcon,
			CloseIcon,
			TutorialIcon,
			VueRangeSlider,
			VairusImage
		}
	}
</script>


<style lang="scss" scoped>
	@import "../styles/variables";
	
	.details{
		position: absolute;
		top: 50%;
		left: 50%;
		transform: translate(-50%, -50%);
		border-radius: 10px;
		width: 900px;
		max-width: 95vw;
		max-height: 95vh;
		overflow-y: auto;
		
		scrollbar-width: thin;
		scrollbar-color: $darkestazure $black;
		
		&::-webkit-scrollbar {
			width: 8px;
		}
		&::-webkit-scrollbar-track {
			background-color: $black;
		}
		&::-webkit-scrollbar-thumb {
			background-color: $darkestazure;
		}
		
		.header{
			.label{
				margin-bottom: 10px;
				width: 180px;
				height: 50px;
				
				span{
				    width: 180px;
					flex-shrink: 0;
				}
				form{
					flex-shrink: 0;
				}
				input{
				    width: 180px;
					flex-shrink: 0;
					background-color: transparent;
					color: $lightestazure;
					border: none;
					border-bottom: 1px solid $lightestazure;
					height: 52px;
					
					&:focus{
						outline: none;
					}
				}
			}
			
			.edit-icon{
				display: none;
				padding: 6px;
				cursor: pointer;
				
				.inner{
				   background-size: cover;
				   width: 20px;
				   height: 20px;
				}
			}
			
			.name-edit{
			    border-radius: 0px;
				padding: 0px;
			}
			
			.label:hover .edit-icon{
				display: inline-block;
			}
			
			.catch-date,
			.category,
			.rarity{
				min-width: 100px;
			}
			
			
			.potential{
				width: 150px;
				
				.text{
					margin-bottom: 7px;
				}
				.bar-wrapper{
					width: 100%;
					align-items: center;
					
					.bar{
						position: relative;
						width: 100%;
						height: 5px;
						background-color: #414557;
						overflow: hidden;
						
						.base{
							background-color: $lightestazure;
							height: 100%;
						}
					}
				}
			}
			
			.close-icon{
				margin-left: 10px;
			}
		}
		
		.content{
			.info{
				width: 420px;
				margin-right: 10px;
				flex-shrink: 0;
				
				.level{
					position: relative;
					border-radius: 0;
					border: 2px solid $lightestazure;
					border-bottom: none;
					z-index: 1;
					
					&:before{
						border-radius: 0;
					}
					
					.top-section{
						padding: 5px 10px;
						background-color: #0E2D3F;
					}
					
					.level-section{
						padding: 10px;
						
						.current-level-bar{
							background-color: $lightestazure;
							height: 6px;
							border-radius: 15px;
						}
					}
					
					.info-section{
						background-color: #0E2D3F;
						overflow: hidden;
						transition: all 0.3s ease 0s;
						height: 0;
						
						table{
							padding: 10px;
							width: 100%;
							text-align: center;
							
							.small-font{
								text-align: left;
							}
							img{
								width: 24px;
								height: 24px;
								object-fit: contain;
							}
						}
					}
					
					&.active{
						.info-section{
							height: 100px;
						}
					}
				}
			
				
				.level-action,
				.mutations-action{
					position: relative;
					height: 40px;
					background-color: none;
					
					.powerup{
						position: absolute;
						right: 0;
						top: 0;
						width: 0;
						height: 100%;
						padding: 10px 0;
						cursor: pointer;
						color: black;
						background-color: $green;
						transition: width 0.3s;
						overflow: hidden;
								
						span{
							position: relative;
						}
							
						&:before{
							content:"";
							position:absolute;
							top:0;
							width: 200%;
							left: 0;
							bottom:0;
							background: linear-gradient(45deg, rgba(255, 255, 255, 0), rgba(255, 255, 255, 0) 20%, rgb(169, 255, 230) 49% 51%, rgba(255, 255, 255, 0) 75%, rgba(255, 255, 255, 0));
							animation: change 2s infinite linear;
						}
						
						&:hover:before{
							animation: change 1s infinite linear;
						}
					}
					
					svg{
						position: absolute;
						left: 0;
						bottom: 0;
						pointer-events: none;
					}
					
					.label{
						position: absolute;
						right: 0;
						top: 0;
						bottom: 0;
						width: 100px;
						padding: 10px;
						white-space: nowrap;
					}
					
					&.active{
						.powerup{
							width: 100%;
							padding: 10px;
						}
						
						.locked{
							display: none;
						}
						
						.label{
							color: $green;
						}
					}
					
					&.locked{
						.powerup{
							width: 100%;
							padding: 10px;
							color: $green;
							background: $black;
							
							.active{
								display: none;
							}
							
							&:before{
								background: $black;
							}
						}
					}
				}

				.mutations{
					position: relative;
					border-radius: 0;
					border: 2px solid $lightestazure;
					border-top: none;
					z-index: 1;

					.bottom-section{
						padding: 5px 10px;
						background-color: #0E2D3F;
						cursor: pointer;
					}
					
					.info-section{
						overflow: hidden;
						transition: all 0.3s ease 0s;
						height: 0;
						
						.wrapper{
							padding: 10px;
							padding-top: 15px;
							
							
							.labels{
								> div{
									height: 22.5px;
								}
							}
							.empty{
								height: 26px !important;
							}
							
							.affinities{
								width: 100%;
						
								.affinity{
									padding: 5px 10px;
									margin: -5px 5px;
									cursor: pointer;
									background-color: #0E2D3F;
									border-radius: 5px;
									
									&.selected,
									&:hover{
										background-color: #082F31;
									}
									
									img{
										width: 20px;
										height: 20px;
										object-fit: contain;
									}
								}
							}
						}
					}
					
					&.active{
						.info-section{
							height: 100px;
						}
					}
				}
				
				.level-action.locked{
					.locked{
						display: block;
					}
				}

				.mutations-action{
					.label{
						cursor: pointer;
						top: 2px;
						
						.mutation{
						    width: 18px;
							height: 18px;
							flex-shrink: 0;
							margin: 0 7px;
							transform: rotate(45deg);
							
							&:not(.active){
								background-color: #0E2D3F;
							}
							
							
							span{
								display: block;
								transform: rotate(-45deg);
								margin-left: 0;
								margin-top: -10px;
								font-size: 1.5rem;
								color: $lightestazure;
							}
							
							&.selected span{
								color: $darkestazure;
							}
						}
					}
				}

				
				.image-wrapper{
					position: relative;
					transition: all 0.3s ease 0s;
					margin-top: 0;
					margin-bottom: 0;
					
					&.slideup{
						margin-top: -100px;
					}
					
					.image{
						position: relative;
						height: 200px;
						width: 200px;
						margin: 20px auto;
						z-index: 0;
						
					}
				
					.exhausted{
						position: absolute;
						left: 50%;
						top: 50%;
						width: 200px;
						height: 200px;
						transform: translate(-50%,-50%);
						background-color: rgba(0,0,0,0.8);
						border: 5px solid $lightestazure;
						color: $lightestazure;
						border-radius: 50%;
						opacity: 1;
						transition: opacity 0.5s;
			
						&.assigned{
							border-color: $lightpink;
							color: $lightpink;
						}
						&.matrix{
							border-color: $lightorange;
							color: $lightorange;
						}
						
						> span{
							position: absolute;
							left: 50%;
							top: 50%;
							transform: translate(-50%,-50%);
							text-transform: uppercase;
							text-align: center;
							line-height: 1.1;
						}
					}
				}
			}
			
			.stats{
				position: relative;
				width: 50%;
				margin-left: 10px;
				
				.graph-wrapper{
					position: absolute;
					top: 50%;
					right: 0;
					width: 100%;
					min-width: 300px;
					min-height: 300px;
					padding-top: 100%;
					transform: translateY(-50%);
					
					
					.graph{
						position: absolute;
						top: 50%;
						left: 50%;
						width: calc(100% - 100px);
						height: calc(100% - 100px);
						transform: translate(-50%,-	50%);
						
						svg{
							width: 100%;
							height: 100%;
						}
					
						.x-axis,
						.y-axis{
							position: absolute;
							top: 0;
							left: 50%;
							height: 100%;
							width: 1px;
							transform: translateX(-50%);
							background-color: $lightestazure;
							
							.stat-label{
								position: absolute;
								bottom: 100%;
								transform: translateX(-50%);
								margin-left: 1px;
								text-transform: uppercase;
								
								&:last-child{
									top: 100%;
									bottom: unset;
								}

								.image{
									display: inline-block;
									position: relative;
									width: 30px;
									height: 30px;
									border-radius: 50%;
									margin: 5px 0;

									img{
										position: absolute;
										left: 5px;
										top: 5px;
										right: 5px;
										bottom: 5px;
										width: 20px;
										height: 20px;
									}
								}
							}
							
							.bubble{
								position: absolute;
							    background-color: #000E12;
								border: 2px solid $lightestazure;
								width: 26px;
								height: 26px;
								border-radius: 50%;
								text-align: center;
								line-height: 23px;
								transform: translateX(-50%);
								margin-left: 1px;
								
								&:first-child{
									top: unset !important;
								}
								&:last-child{
									bottom: unset !important;
								}
							}
						}
						.x-axis{
							transform: translateX(-50%) rotate(90deg);
							
							img{
								transform: rotate(-90deg);
							}
							.bubble{
								transform: translateX(-50%) rotate(-90deg);
							}
						}
					}
				}
				
			}
		}
	}
	
	@media screen and (max-width: 900px) {
		.details .header .label:hover .edit-icon{
			display: none !important;
		}
	}
	
	@media screen and (max-width: 740px) {
		.vairus-details{
			.header{
				margin-bottom: 20px;
				flex-wrap: wrap;
				
				.label, .catch-date, .potential{
					width: 50%;
					flex-shrink: 0;
				}
				.category, .rarity {
					width: 25%;
					flex-shrink: 0;
				}
				
				.icons{
					position: absolute;
					right: 20px;
					top: 20px;
				}
			}
			.content{
				display: block;
				
				.info,
				.stats{
					margin: 0 auto;
					
					.graph-wrapper{
						position: relative;
						top: 0;
						transform: none;
						margin-top: 25px;
					}
				}
				.stats{
					width: 100%;
				}
			}
		}
	}
	
	@media screen and (max-width: 500px) {
		.vairus-details{
			.header{
				.label{
					width: 35%;
				}
				.catch-date{
					width: 65%;
				}
				.category, .rarity {
					width: 50%;
				}
				.potential{
					width: 100%;
					margin-top: 10px;
				}
			}
		}
		.details .content .info{
			width: auto;
			overflow: hidden;
			
			svg{
				height: 40px;
				left: unset !important;
				right: 0;
			}
		}
	}

	@keyframes change {
		to { transform:translate(-84%); }
	}
</style>






